using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Drawing2D;
using Syncfusion.Windows.Forms.Chart;

namespace MultipleYAxes
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private ChartAxis axis1 = new ChartAxis();
        private ChartAxis axis2 = new ChartAxis();
        private Label label1;
        private ComboBox comboBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		private void InitializeControlSettings()
		{
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

			// Specify a ChartPalette:
			Color[] color = new Color[]{Color.FromArgb(185, 73,141,238), Color.FromArgb(185,247,179,78),Color.FromArgb(185,186,66,30), Color.FromArgb(185,242,19,78),Color.FromArgb(185,104,15,78),Color.FromArgb(185,79,189,23)};
			this.chartControl1.Palette = ChartColorPalette.Custom ;
			this.chartControl1.Model.ColorModel.CustomColors = color;
			this.chartControl1.Palette = ChartColorPalette.Custom ;

			this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
			this.chartControl1.LegendPosition = ChartDock.Top;
			this.chartControl1.HidePartialLabels = true;
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
            this.label1 = new System.Windows.Forms.Label();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.SuspendLayout();
            // 
            // chartControl1
            // 
            this.chartControl1.BackInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
            // 
            // 
            // 
            this.chartControl1.ChartArea.AxesSideBySide = true;
            this.chartControl1.ChartArea.BackInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
            this.chartControl1.ChartArea.ChartAreaMargins.Bottom = 10;
            this.chartControl1.ChartArea.ChartAreaMargins.Left = 10;
            this.chartControl1.ChartArea.ChartAreaMargins.Right = 20;
            this.chartControl1.ChartArea.ChartAreaMargins.Top = 10;
            this.chartControl1.ChartArea.ChartPlotAreaMargins.Bottom = 10;
            this.chartControl1.ChartArea.ChartPlotAreaMargins.Left = 10;
            this.chartControl1.ChartArea.ChartPlotAreaMargins.Right = 20;
            this.chartControl1.ChartArea.ChartPlotAreaMargins.Top = 10;
            this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Horizontal, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(209)))), ((int)(((byte)(226))))), System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(232)))), ((int)(((byte)(243))))));
            // 
            // 
            // 
            this.chartControl1.Legend.BackColor = System.Drawing.SystemColors.Control;
            this.chartControl1.Legend.Font = new System.Drawing.Font("Verdana", 10F);
            this.chartControl1.Legend.ItemsShadowColor = System.Drawing.Color.Gray;
            this.chartControl1.Legend.Location = new System.Drawing.Point(240, 469);
            this.chartControl1.Legend.Name = "";
            this.chartControl1.Legend.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
            this.chartControl1.Legend.RepresentationType = Syncfusion.Windows.Forms.Chart.ChartLegendRepresentationType.None;
            this.chartControl1.Legend.TabIndex = 3;
            this.chartControl1.Legend.TextColor = System.Drawing.Color.Black;
            this.chartControl1.LegendPosition = Syncfusion.Windows.Forms.Chart.ChartDock.Bottom;
            this.chartControl1.Location = new System.Drawing.Point(0, 0);
            this.chartControl1.Name = "chartControl1";
            this.chartControl1.Palette = Syncfusion.Windows.Forms.Chart.ChartColorPalette.Default;
            this.chartControl1.PrimaryXAxis.LabelAligment = System.Drawing.StringAlignment.Center;
            this.chartControl1.PrimaryXAxis.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
            this.chartControl1.PrimaryYAxis.LabelAligment = System.Drawing.StringAlignment.Center;
            this.chartControl1.Size = new System.Drawing.Size(568, 507);
            this.chartControl1.TabIndex = 0;
            this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(587, 164);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(107, 13);
            this.label1.TabIndex = 2;
            this.label1.Text = "Select No. of Series :";
            // 
            // comboBox1
            // 
            this.comboBox1.FormattingEnabled = true;
            this.comboBox1.Location = new System.Drawing.Point(590, 195);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(121, 21);
            this.comboBox1.TabIndex = 5;
            this.comboBox1.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(731, 508);
            this.Controls.Add(this.comboBox1);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.chartControl1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.SizeChanged += new System.EventHandler(this.Form1_SizeChanged);
            this.Load += new System.EventHandler(this.Form1_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		protected void InitializeChart()
		{
            Random r = new Random();
            this.chartControl1.ShowToolTips = true;

            // Intialize Axis
            this.chartControl1.BeginUpdate();
            if (Convert.ToInt32(this.comboBox1.Text) > 0)
            {
                this.chartControl1.ChartArea.BoundsByAxes = false;

                this.chartControl1.PrimaryXAxis.DrawGrid = false;
                this.chartControl1.PrimaryYAxis.DrawGrid = false;
                this.chartControl1.PrimaryYAxis.RangeType = ChartAxisRangeType.Set;
                this.chartControl1.PrimaryYAxis.Range = new MinMaxInfo(20, 40, 5);
                this.chartControl1.PrimaryYAxis.ForeColor = Color.FromArgb(185, 73, 141, 238);
                this.chartControl1.PrimaryYAxis.Title = "Basic Rate";

                ChartSeries series = this.chartControl1.Model.NewSeries("Line 1", ChartSeriesType.Line);
                series.Text = series.Name;

                for (int i = 0; i < 5; i++)
                    series.Points.Add(i, r.Next(20, 40));

                series.PointsToolTipFormat = "{4}";
                this.chartControl1.Series.Add(series);
                series.PrepareStyle += new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyle);

                this.chartControl1.PrimaryYAxis.AutoSize = false;
                this.chartControl1.PrimaryYAxis.Size = new SizeF(0, (float)(this.chartControl1.ChartArea.RenderBounds.Height / (Convert.ToInt32(this.comboBox1.Text) + 1)) - 10);
            }
            if (Convert.ToInt32(this.comboBox1.Text) > 1)
            {
                axis1.Orientation = ChartOrientation.Vertical;
                axis1.OpposedPosition = false;
                axis1.RangeType = ChartAxisRangeType.Set;
                axis1.Range = new MinMaxInfo(50, 75, 5);
                axis1.DrawGrid = false;
                axis1.ForeColor = Color.FromArgb(185, 247, 179, 78);
                axis1.Title = "Rate A";
                this.chartControl1.Axes.Add(axis1);

                ChartSeries series = this.chartControl1.Model.NewSeries("Line 2", ChartSeriesType.Line);
                series.Text = series.Name;

                for (int i = 0; i < 5; i++)
                    series.Points.Add(i, r.Next(50, 75));

                series.PointsToolTipFormat = "{4}";
                this.chartControl1.Series.Add(series);
                series.YAxis = this.axis1;
                series.PrepareStyle += new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyle1);

                axis1.LocationType = ChartAxisLocationType.Set;
                axis1.Location = new PointF(this.chartControl1.PrimaryXAxis.Location.X, (float)(this.chartControl1.ChartArea.RenderBounds.Bottom - this.chartControl1.ChartArea.RenderBounds.Height / (Convert.ToInt32(this.comboBox1.Text) + 1)));
                axis1.AutoSize = false;
                axis1.Size = new SizeF(0, (float)(this.chartControl1.ChartArea.RenderBounds.Height / (Convert.ToInt32(this.comboBox1.Text) + 1)) - 10);
            }
            if (Convert.ToInt32(this.comboBox1.Text) > 2)
            {
                axis2.Orientation = ChartOrientation.Vertical;
                axis2.OpposedPosition = false;
                axis2.RangeType = ChartAxisRangeType.Set;
                axis2.Range = new MinMaxInfo(200, 300, 20);
                axis2.DrawGrid = false;
                axis2.ForeColor = Color.FromArgb(185, 186, 66, 30);
                axis2.Title = "Rate B";
                this.chartControl1.Axes.Add(axis2);

                ChartSeries series = this.chartControl1.Model.NewSeries("Line 3", ChartSeriesType.StepLine);
                series.Text = series.Name;
                for (int i = 0; i < 5; i++)
                    series.Points.Add(i, r.Next(200, 300));

                series.PointsToolTipFormat = "{4}";
                this.chartControl1.Series.Add(series);
                series.YAxis = this.axis2;

                series.PrepareStyle += new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyle2);

                axis2.LocationType = ChartAxisLocationType.Set;
                axis2.Location = new PointF(this.chartControl1.PrimaryXAxis.Location.X, (float)(this.chartControl1.ChartArea.RenderBounds.Bottom - this.chartControl1.ChartArea.RenderBounds.Height * 2 / (Convert.ToInt32(this.comboBox1.Text) + 1)));
                axis2.AutoSize = false;
                axis2.Size = new SizeF(0, (float)(this.chartControl1.ChartArea.RenderBounds.Height / (Convert.ToInt32(this.comboBox1.Text) + 1)) - 10);
            }
            this.chartControl1.EndUpdate();
            this.chartControl1.Redraw(true);
		}

		protected void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
			Random rand = new Random();
			if(series != null)
			{
				args.Style.Text = string.Format("{0:C}", series.Points[args.Index].YValues[0]);
				args.Style.DisplayText = true;
				args.Style.TextColor = Color.Blue;
				args.Style.Symbol.Shape=ChartSymbolShape.InvertedTriangle;
				args.Style.Symbol.Color=Color.Red;
				args.Style.Symbol.Size=new Size(7,7);
				args.Style.TextOrientation=ChartTextOrientation.Up;
				
			}
			
		}

		protected void ChartControlSeries_PrepareStyle1(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
            series.EnableStyles = true;
			Random rand = new Random();
			if(series != null)
			{
                if (args.Index == 3)
                {
                    //args.Style.BeginUpdate();
                    args.Style.Border.DashStyle = DashStyle.Dash;
                    args.Handled = true;
                    //args.Style.EndUpdate();
                }
                args.Style.Text = string.Format("{0:C}", series.Points[args.Index].YValues[0]);
				args.Style.DisplayText = true;
				args.Style.TextColor = Color.Crimson;
				args.Style.Symbol.Shape=ChartSymbolShape.Diamond;
				args.Style.Symbol.Color=Color.Black;
				args.Style.Symbol.Size=new Size(7,7);
				args.Style.TextOrientation=ChartTextOrientation.Up;

				
			}
			
		}
		protected void ChartControlSeries_PrepareStyle2(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
			Random rand = new Random();
			if(series != null)
			{
				args.Style.Text = string.Format("{0:C}", series.Points[args.Index].YValues[0]);
				args.Style.DisplayText = true;
				args.Style.TextColor = Color.DarkGreen;
				args.Style.Symbol.Shape=ChartSymbolShape.Square;
				args.Style.Symbol.Color=Color.Yellow;
				args.Style.Symbol.Size=new Size(7,7);
				args.Style.TextOrientation=ChartTextOrientation.Up;

				
			}
			if(args.Index==2)
			{
				args.Style.Border.DashStyle=DashStyle.DashDotDot;
			}
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.chartControl1.Legend.VisibleCheckBox=true;
				
			InitializeControlSettings();
			this.chartControl1.ChartAreaMargins.Left = 20;
			this.chartControl1.ShowToolTips = true;
            this.chartControl1.Series.Clear();
            this.comboBox1.Items.Add("1");
            this.comboBox1.Items.Add("2");
            this.comboBox1.Items.Add("3");
            MessageBox.Show(this.chartControl1.ChartArea.Axes.Count.ToString());
        }

		private void Form1_SizeChanged(object sender, System.EventArgs e)
		{
			
			this.chartControl1.ChartArea.BoundsByAxes = false;
		}

		private void chartControl1_VisibleChanged(object sender, System.EventArgs e)
		{
			this.chartControl1.ChartArea.BoundsByAxes = false;
		}

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.chartControl1.Series.Clear();
            if (this.chartControl1.ChartArea.Axes.Count > 2)
            {
                int i;
                for (i = 2; i < this.chartControl1.ChartArea.Axes.Count; i = i + 1)
                {
                    this.chartControl1.BeginUpdate();
                    this.chartControl1.ChartArea.Axes.RemoveAt(i);
                    //this.chartControl1.Redraw(true);
                    this.chartControl1.Refresh();
                    this.chartControl1.EndUpdate();
                }
                MessageBox.Show("post" + this.chartControl1.ChartArea.Axes.Count.ToString());
            }
            InitializeChart();
        }
	}
}
